---
title: BaseAudioContext.decodeAudioData()
slug: Web/API/BaseAudioContext/decodeAudioData
tags:
  - API
  - Audio
  - AudioContext
  - BaseAudioContext
  - Method
  - Reference
  - Web Audio API
  - decodeAudioData
---
<p>{{ APIRef("Web Audio API") }}</p>

<p>The <code>decodeAudioData()</code> method of the {{ domxref("BaseAudioContext") }} Interface is used to asynchronously decode audio file data contained in an {{domxref("ArrayBuffer")}}. In this case the <code>ArrayBuffer</code> is loaded from {{domxref("XMLHttpRequest")}} and {{domxref("FileReader")}}. The decoded {{domxref("AudioBuffer")}} is resampled to the {{domxref("AudioContext")}}'s sampling rate, then passed to a callback or promise.</p>

<p>This is the preferred method of creating an audio source for Web Audio API from an audio track. This method only works on complete file data, not fragments of audio file data.</p>

<h2 id="Syntax">Syntax</h2>

<p>Older callback syntax:</p>

<pre class="syntaxbox notranslate">baseAudioContext.decodeAudioData(<var>ArrayBuffer</var>, <var>successCallback</var>, <var>errorCallback</var>);</pre>

<p>Newer promise-based syntax:</p>

<pre class="syntaxbox notranslate">Promise&lt;decodedData&gt; baseAudioContext.decodeAudioData(<var>ArrayBuffer</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><var>ArrayBuffer</var></dt>
 <dd>An ArrayBuffer containing the audio data to be decoded, usually grabbed from {{domxref("XMLHttpRequest")}}, {{domxref("WindowOrWorkerGlobalScope.fetch()")}} or {{domxref("FileReader")}}.</dd>
 <dt><var>successCallback</var></dt>
 <dd>A callback function to be invoked when the decoding successfully finishes. The single argument to this callback is an {{domxref("AudioBuffer")}} representing the <var>decodedData</var> (the decoded PCM audio data). Usually you'll want to put the decoded data into an {{domxref("AudioBufferSourceNode")}}, from which it can be played and manipulated how you want.</dd>
 <dt><var>errorCallback</var></dt>
 <dd>An optional error callback, to be invoked if an error occurs when the audio data is being decoded.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>Void, or a {{domxref("Promise") }} object that fulfills with the <var>decodedData</var>.</p>

<h2 id="Example">Example</h2>

<p>In this section we will first cover the older callback-based system and then the newer promise-based syntax.</p>

<h3 id="Older_callback_syntax">Older callback syntax</h3>

<p>In this example, the <code>getData()</code> function uses XHR to load an audio track, setting the <code>responseType</code> of the request to <code>arraybuffer</code> so that it returns an array buffer as its <code>response</code> that we then store in the <code>audioData</code> variable . We then pass this buffer into a <code>decodeAudioData()</code> function; the success callback takes the successfully decoded PCM data, puts it into an {{ domxref("AudioBufferSourceNode") }} created using {{ domxref("AudioContext.createBufferSource()") }}, connects the source to the {{domxref("AudioContext.destination") }} and sets it to loop.</p>

<p>The buttons in the example run <code>getData()</code> to load the track and start it playing, and stop it playing, respectively. When the <code>stop()</code> method is called on the source, the source is cleared out.</p>

<div class="note">
<p><strong>Note</strong>: You can <a href="https://mdn.github.io/webaudio-examples/decode-audio-data/">run the example live</a> (or <a href="https://github.com/mdn/webaudio-examples/tree/master/decode-audio-data">view the source</a>.)</p>
</div>

<pre class="brush: js notranslate">// define variables

var audioCtx = new (window.AudioContext || window.webkitAudioContext)();
var source;

var pre = document.querySelector('pre');
var myScript = document.querySelector('script');
var play = document.querySelector('.play');
var stop = document.querySelector('.stop');

// use XHR to load an audio track, and
// decodeAudioData to decode it and stick it in a buffer.
// Then we put the buffer into the source

function getData() {
  source = audioCtx.createBufferSource();
  var request = new XMLHttpRequest();

  request.open('GET', 'viper.ogg', true);

  request.responseType = 'arraybuffer';

  request.onload = function() {
    var audioData = request.response;

    audioCtx.decodeAudioData(audioData, function(buffer) {
        source.buffer = buffer;

        source.connect(audioCtx.destination);
        source.loop = true;
      },

      function(e){ console.log("Error with decoding audio data" + e.err); });

  }

  request.send();
}

// wire up buttons to stop and play audio

play.onclick = function() {
  getData();
  source.start(0);
  play.setAttribute('disabled', 'disabled');
}

stop.onclick = function() {
  source.stop(0);
  play.removeAttribute('disabled');
}

// dump script to pre element

pre.innerHTML = myScript.innerHTML;</pre>

<h3 id="New_promise-based_syntax">New promise-based syntax</h3>

<pre class="brush: js notranslate">ctx.decodeAudioData(audioData).then(function(decodedData) {
 // use the decoded data here
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-baseaudiocontext-decodeaudiodata', 'decodeAudioData()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.BaseAudioContext.decodeAudioData")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
